Index: /branches/CEDMA-Refactoring-Ticket419/HeuristicLab.GP.StructureIdentification.TimeSeries/OffspringSelectionGP.cs
===================================================================
--- /branches/CEDMA-Refactoring-Ticket419/HeuristicLab.GP.StructureIdentification.TimeSeries/OffspringSelectionGP.cs	(revision 1264)
+++ /branches/CEDMA-Refactoring-Ticket419/HeuristicLab.GP.StructureIdentification.TimeSeries/OffspringSelectionGP.cs	(revision 1265)
@@ -35,6 +35,6 @@
   public class OffspringSelectionGP : HeuristicLab.GP.StructureIdentification.OffspringSelectionGP {
     public virtual bool Autoregressive {
-      get { return GetVariableInjector().GetVariable("Autoregressive").GetValue<BoolData>().Data; }
-      set { GetVariableInjector().GetVariable("Autoregressive").GetValue<BoolData>().Data = value; }
+      get { return ProblemInjector.GetVariable("Autoregressive").GetValue<BoolData>().Data; }
+      set { ProblemInjector.GetVariable("Autoregressive").GetValue<BoolData>().Data = value; }
     }
 
@@ -45,10 +45,4 @@
     protected override IOperator CreateProblemInjector() {
       return new ProblemInjector();
-    }
-
-    protected override IOperator CreateGlobalInjector() {
-      VariableInjector injector = (VariableInjector)base.CreateGlobalInjector();
-      injector.AddVariable(new HeuristicLab.Core.Variable("Autoregressive", new BoolData()));
-      return injector;
     }
 
@@ -66,10 +60,4 @@
       return new OffspringSelectionGpEditor(this);
     }
-
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
-      OffspringSelectionGP clone = (OffspringSelectionGP)base.Clone(clonedObjects);
-      clone.Autoregressive = Autoregressive;
-      return clone;
-    }
   }
 }
Index: /branches/CEDMA-Refactoring-Ticket419/HeuristicLab.GP.StructureIdentification.TimeSeries/ProblemInjector.cs
===================================================================
--- /branches/CEDMA-Refactoring-Ticket419/HeuristicLab.GP.StructureIdentification.TimeSeries/ProblemInjector.cs	(revision 1264)
+++ /branches/CEDMA-Refactoring-Ticket419/HeuristicLab.GP.StructureIdentification.TimeSeries/ProblemInjector.cs	(revision 1265)
@@ -40,4 +40,8 @@
     public ProblemInjector()
       : base() {
+      AddVariableInfo(new Core.VariableInfo("Autoregressive", "Autoregressive modelling includes previous values of the target variable to predict future values.", typeof(BoolData), Core.VariableKind.New));
+      GetVariableInfo("Autoregressive").Local = true;
+      AddVariable(new Core.Variable("Autoregressive", new BoolData()));
+
       AddVariableInfo(new Core.VariableInfo("MaxTimeOffset", "MaxTimeOffset", typeof(IntData), Core.VariableKind.New));
       GetVariableInfo("MaxTimeOffset").Local = true;
Index: /branches/CEDMA-Refactoring-Ticket419/HeuristicLab.GP.StructureIdentification.TimeSeries/StandardGP.cs
===================================================================
--- /branches/CEDMA-Refactoring-Ticket419/HeuristicLab.GP.StructureIdentification.TimeSeries/StandardGP.cs	(revision 1264)
+++ /branches/CEDMA-Refactoring-Ticket419/HeuristicLab.GP.StructureIdentification.TimeSeries/StandardGP.cs	(revision 1265)
@@ -35,6 +35,6 @@
   public class StandardGP : HeuristicLab.GP.StructureIdentification.StandardGP {
     public bool Autoregressive {
-      get { return GetVariableInjector().GetVariable("Autoregressive").GetValue<BoolData>().Data; }
-      set { GetVariableInjector().GetVariable("Autoregressive").GetValue<BoolData>().Data = value; }
+      get { return ProblemInjector.GetVariable("Autoregressive").GetValue<BoolData>().Data; }
+      set { ProblemInjector.GetVariable("Autoregressive").GetValue<BoolData>().Data = value; }
     }
 
@@ -45,10 +45,4 @@
     protected override IOperator CreateProblemInjector() {
       return new ProblemInjector();
-    }
-
-    protected override IOperator CreateGlobalInjector() {
-      VariableInjector injector = (VariableInjector)base.CreateGlobalInjector();
-      injector.AddVariable(new HeuristicLab.Core.Variable("Autoregressive", new BoolData()));
-      return injector;
     }
 
@@ -137,9 +131,4 @@
       }
     }
-    public override object Clone(IDictionary<Guid, object> clonedObjects) {
-      OffspringSelectionGP clone = (OffspringSelectionGP)base.Clone(clonedObjects);
-      clone.Autoregressive = Autoregressive;
-      return clone;
-    }
   }
 }